<?php
/*
Plugin Name: pwg.images.addSimple
Version: 2.1b
Description: A simpler method to add photo with web API, based on HTTP file upload protocol
Plugin URI: http://piwigo.org/ext/extension_view.php?eid=411
Author: plg
Author URI: http://piwigo.wordpress.com
*/

if (!defined('PHPWG_ROOT_PATH'))
{
  die('Hacking attempt!');
}

add_event_handler('ws_add_methods', 'ws_add_method_addSimple');

function ws_add_method_addSimple($arr)
{
  global $conf;
  $service = &$arr[0];
  
  $service->addMethod(
    'pwg.images.addSimple',
    'ws_images_addSimple',
    array(
      'category' => array('default' => null),
      'name' => array('default' => null),
      'author' => array('default' => null),
      'comment' => array('default' => null),
      'level' => array(
        'default' => 0,
        'maxValue' => $conf['available_permission_levels']
        ),
      'tags' => array('default' => null),
      ),
    'POST method only.<br>Use the <b>image</b> field for uploading file.<br>Set the form encoding to "form-data"<br><b>category</b> is the numeric identifier of the destination category.'
    );
}

function ws_images_addSimple($params, &$service)
{
  global $conf;
  if (!is_admin() || is_adviser() )
  {
    return new PwgError(401, 'Access denied');
  }

  if (!$service->isPost())
  {
    return new PwgError(405, "This method requires HTTP POST");
  }

  // category
  $params['category'] = (int)$params['category'];
  if ($params['category'] <= 0)
  {
    return new PwgError(WS_ERR_INVALID_PARAM, "Invalid category_id");
  }

  include_once(PHPWG_ROOT_PATH.'admin/include/functions_upload.inc.php');
  
  $image_id = add_uploaded_file(
    $_FILES['image']['tmp_name'],
    $_FILES['image']['name'],
    array($params['category']),
    8
    );

  $info_columns = array(
    'name',
    'author',
    'comment',
    'level',
    'date_creation',
    );

  foreach ($info_columns as $key)
  {
    if (isset($params[$key]))
    {
      $update[$key] = $params[$key];
    }
  }

  if (count(array_keys($update)) > 0)
  {
    $update['id'] = $image_id;

    include_once(PHPWG_ROOT_PATH.'admin/include/functions.php');
    mass_updates(
      IMAGES_TABLE,
      array(
        'primary' => array('id'),
        'update'  => array_diff(array_keys($update), array('id'))
        ),
      array($update)
      );
  }


  if (isset($params['tags']) and !empty($params['tags']))
  {
    $tag_ids = array();
    $tag_names = explode(',', $params['tags']);
    foreach ($tag_names as $tag_name)
    {
      $tag_id = tag_id_from_tag_name($tag_name);
      array_push($tag_ids, $tag_id);
    }

    add_tags($tag_ids, array($image_id));
  }

  $query = '
SELECT id, name, permalink
  FROM '.CATEGORIES_TABLE.'
  WHERE id = '.$params['category'].'
;';
  $result = pwg_query($query);
  $category = pwg_db_fetch_assoc($result);

  return array(
    'image_id' => $image_id,
    'url' => make_picture_url(
      array(
        'image_id' => $image_id,
        'section' => 'categories',
        'category' => $category
        )
      ),
    );
}
?>
